/**
 * Der Abschluss einer Warteschlange.
 * 
 * @author Bernd Gramlich
 * @version 2012-11-09
 */
public class Abschluss extends Schlangenelement
{
    /**
     * Konstruktor.
     * Der Abschluss der Schlange enthlt nichts.
     * Deshalb braucht auch nichts getan zu werden.
     */
    public Abschluss ()
    {
    }

    /**
     * Nenne meinen Nachfolger.
     * Mein Nachfolger ist null, da ich der
     * Abschluss der Schlange bin.
     */
     public Schlangenelement gibNachfolger ()
     {
         return null;
     }

    /**
     * Nenne meinen Inhalt.
     * Mein Nachfolger ist null, da ich der
     * Abschluss der Schlange bin.
     */
    public Person gibInhalt ()
    {
        return null;
    }
     
     /**
      * Fge hinten an die Schlange als n-tes Schlangenelement
      * einen Knoten mit den Daten an.
      * 
      * Da ich der Abschluss bin, erzeuge ich einen neuen
      * Knoten mit mir als Nachfolger. Den Verweis auf mich
      * selbst erziele ich durch das Java-Schlsselwort "this".
      */
     public Schlangenelement stelleHintenAn (int n, boolean weiblich,
        String name, String hautfarbe, String haarfarbe, String schuhfarbe,
        String kleiderfarbe1, String kleiderfarbe2, String kleiderfarbe3)
     {
         return new Knoten (this, (n-1) * 100, 30, weiblich, name,
            hautfarbe, haarfarbe, schuhfarbe, kleiderfarbe1,
            kleiderfarbe2, kleiderfarbe3);
     }
     
    /**
     * Lsche unter meinen Nachfolgern die erste Person namens
     * "name". Da ich der Abschluss bin, gib es keinen solchen
     * Nachfolger. Ich gebe also "null" zurck.
     */
    public Person loescheNachfolgerNamens (String name)
    {
        return null;
    }
    
    /**
     * Nenne die Lnge der Schlange von mir selbst ab.
     */
    public int gibLaenge ()
    {
        return 0;
    }
   
    /**
     * Zhle alle Frauen von mir selbst ab.
     */
    public int gibFrauenzahl ()
    {
        return 0;
    }

    /**
     * Zhle alle Mnner von mir selbst ab.
     */
    public int gibMaennerzahl ()
    {
        return 0;
    }

    /**
     * Zhle alle Blondinen von mir selbst ab.
     */
    public int gibBlondinenzahl ()
    {
        return 0;
    }

    /**
     * Nenne die Anzahl der Buchstaben in allen Namen der Schlange
     * von mir selbst ab.
     */
    public int gibGesamtbuchstabenzahl ()
    {
        return 0;
    }

    /**
     * Nenne alle Namen in der Schlange von mir selbst ab.
     */
    public String nenneAlleNamen ()
    {
        return "";
    }

    /**
     * Zhle alle Anzugtrger von mir selbst ab.
     */
    public int gibAnzugtraegerzahl ()
    {
        return 0;
    }

    /**
     * Zhle alle Kleidtrgerinnen von mir selbst ab.
     */
    public int gibKleidtraegerinnenzahl ()
    {
        return 0;
    }

    /**
     * Zhle alle Leute mit Anfangsbuchstabe L von mir selbst ab.
     */
    public int zaehleAnfangsbuchstabeL ()
    {
        return 0;
    }

    /**
     * Verkrze meinen und alle weitere Namen in der Schlange
     * auf einen dreibuchstabigen Spitznamen.
     */
    public void verkuerzeNamen ()
    {
    }

    /**
     * Verschiebe den Knoten und alle seine Nachfolger um
     * 100 Bildpunkte nach links.
     */
    public void verschiebeNachLinks ()
    {
    }

    /**
     * Verschiebe den Knoten und alle seine Nachfolger um
     * 100 Bildpunkte nach rechts.
     */
    public void verschiebeNachRechts ()
    {
    }

    /**
     * Fge einen schwarzen Peter unmittelbar vor meinem Nachfolger
     * namens "name" ein. Ich selbst bin der n-te Kunde.
     */
    public void draengleVorNachfolgerNamens (String name, int n)
    {
    }
}
