/**
 * Ein Element einer Warteschlange.
 * Die Klasse ist abstrakt, da ein Schlangenelement
 * entweder ein Knoten (mit Daten) oder der Abschluss
 * der Schlange sein kann.
 * 
 * @author Bernd Gramlich 
 * @version 2012-11-09
 */
public abstract class Schlangenelement
{
    /*
     * Die Klasse selbst hat keinen Konstruktor, sondern nur
     * ihre Unterklassen.
     */
    
    /**
     * Nenne den Nachfolger des Schlangenelements.
     */
    public abstract Schlangenelement gibNachfolger ();

    /**
     * Nenne den Inhalt des Listenelements.
     */
    public abstract Person gibInhalt ();
    
    /**
     * Stelle hinten an die Schlange den neuen Kunden mit den
     * Daten an. Ich selbst bin der n-te Kunde.
     */
    public abstract Schlangenelement stelleHintenAn (int n, boolean weiblich,
        String name, String hautfarbe, String haarfarbe, String schuhfarbe,
        String kleiderfarbe1, String kleiderfarbe2, String kleiderfarbe3);
        
    /**
     * Lsche unter meinen Nachfolgern die erste Person namens
     * "name".
     */
    public abstract Person loescheNachfolgerNamens (String name);
    
    /**
     * Nenne die Lnge der Schlange von mir selbst ab.
     */
    public abstract int gibLaenge ();
    
    /**
     * Zhle alle Frauen von mir selbst ab.
     */
    public abstract int gibFrauenzahl ();

    /**
     * Zhle alle Mnner von mir selbst ab.
     */
    public abstract int gibMaennerzahl ();

    /**
     * Zhle alle Blondinen von mir selbst ab.
     */
    public abstract int gibBlondinenzahl ();

    /**
     * Nenne die Anzahl der Buchstaben in allen Namen der Schlange
     * von mir selbst ab.
     */
    public abstract int gibGesamtbuchstabenzahl ();

    /**
     * Nenne alle Namen in der Schlange von mir selbst ab.
     */
    public abstract String nenneAlleNamen ();

    /**
     * Zhle alle Anzugtrger von mir selbst ab.
     */
    public abstract int gibAnzugtraegerzahl ();

    /**
     * Zhle alle Kleidtrgerinnen von mir selbst ab.
     */
    public abstract int gibKleidtraegerinnenzahl ();

    /**
     * Zhle alle Leute mit Anfangsbuchstabe L von mir selbst ab.
     */
    public abstract int zaehleAnfangsbuchstabeL ();

    /**
     * Verkrze meinen und alle weitere Namen in der Schlange
     * auf einen dreibuchstabigen Spitznamen.
     */
    public abstract void verkuerzeNamen ();

    /**
     * Verschiebe den Knoten und alle seine Nachfolger um
     * 100 Bildpunkte nach links.
     */
    public abstract void verschiebeNachLinks ();

    /**
     * Verschiebe den Knoten und alle seine Nachfolger um
     * 100 Bildpunkte nach rechts.
     */
    public abstract void verschiebeNachRechts ();

    /**
     * Fge einen schwarzen Peter unmittelbar vor meinem Nachfolger
     * namens "name" ein. Ich selbst bin der n-te Kunde.
     */
    public abstract void draengleVorNachfolgerNamens (String name, int n);
}
